VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form dlgTableTerramodel 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Dialog Caption"
   ClientHeight    =   3540
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   10485
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3540
   ScaleWidth      =   10485
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdBack 
      Caption         =   "Back"
      Height          =   375
      Left            =   6360
      TabIndex        =   2
      Top             =   3120
      Width           =   1215
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   375
      Left            =   7680
      TabIndex        =   1
      Top             =   3120
      Width           =   1215
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   9120
      TabIndex        =   0
      Top             =   3120
      Width           =   1215
   End
   Begin MSFlexGridLib.MSFlexGrid GridData 
      Height          =   2415
      Left            =   1560
      TabIndex        =   3
      Top             =   360
      Width           =   8595
      _ExtentX        =   15161
      _ExtentY        =   4260
      _Version        =   393216
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "dlgTableTerramodel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Private Sub Form_Load()
Dim ARRAYTEXT() As String
Dim ARRAYTEXTidx As Integer
Dim DATASTRING As String
Dim ARRAYDATAidx As Integer
' Set the grid
   With GridData
      .FixedCols = 0
      .Cols = 4 ' for the values
      .FixedRows = 1 ' for the titels
      .Rows = 1 ' for the titels
      .TextMatrix(0, 0) = "Initial Depth"
      .TextMatrix(0, 1) = "End Depth"
      .TextMatrix(0, 2) = "Cut Volume"
      .TextMatrix(0, 3) = "Fill Volume"
      .ColWidth(0) = (.Width - 480) / 4
      .ColWidth(1) = (.Width - 480) / 4
      .ColWidth(2) = (.Width - 480) / 4
      .ColWidth(3) = (.Width - 480) / 4
   End With
' split TextEdit in Array with lines of data
   ARRAYTEXT = Split(dlgContentTerramodel.TextEdit, vbNewLine)
' check col separators 1 and 2: 1 must be before 2
   If COLSEP(1) >= COLSEP(2) Then GoTo Error_Cols_Value
' Fill ArrayData
   ReDim ARRAYDATA(0) ' set ARRAYDATA =0 lines
   For ARRAYTEXTidx = 0 To UBound(ARRAYTEXT) - 1 ' loop trough the ARRAYTEXT
      ReDim Preserve ARRAYDATA(UBound(ARRAYDATA) + 1) ' add 1 blanco line to ARRAYDATA
      With ARRAYDATA(UBound(ARRAYDATA)) ' fill the last line (blanco) with values
         ' 1st col
         DATASTRING = Trim(Left(ARRAYTEXT(ARRAYTEXTidx), COLSEP(1))) ' trimmed string, left of dataline, to colsep(1)
         .DEPTH1 = Left(DATASTRING, InStr(DATASTRING, " ") - 1) 'add it to the ARRAYDATA.DEPTH1 field
         .DEPTH2 = Mid(DATASTRING, InStrRev(DATASTRING, " ") + 1) 'add it to the ARRAYDATA.DEPTH2 field
         ' 2nd col !! IF there is data
         DATASTRING = Trim(Mid(ARRAYTEXT(ARRAYTEXTidx), COLSEP(1) + 1, (COLSEP(2) - COLSEP(1)))) ' trim between the colsep values
         If DATASTRING <> "" Then .CUTVOL = DATASTRING ' if there is a value, add it to the ARRAYDATA.CUTVOL field
         ' 3rd col !! IF there is a value in the 3rd col
         DATASTRING = Trim(Mid(ARRAYTEXT(ARRAYTEXTidx), COLSEP(2) + 1)) ' trim last value
         If Len(ARRAYTEXT(ARRAYTEXTidx)) > COLSEP(2) Then .FILLVOL = DATASTRING ' if there is a value, add it to the ARRAYDATA.CUTVOL field
      End With
   Next
   ReDim Preserve ARRAYDATA(UBound(ARRAYDATA) + 1) ' add 1 blanco line to ARRAYDATA
   ARRAYDATA(UBound(ARRAYDATA)).DEPTH1 = ARRAYDATA(UBound(ARRAYDATA) - 1).DEPTH2
' Dump ArrayData in Grid
   GridData.Rows = 1
   For ARRAYDATAidx = 1 To UBound(ARRAYDATA) ' loop trough the ARRAYDATA and add each line in the GridData
      GridData.AddItem ARRAYDATA(ARRAYDATAidx).DEPTH1 & vbTab & _
                           ARRAYDATA(ARRAYDATAidx).DEPTH2 & vbTab & _
                           ARRAYDATA(ARRAYDATAidx).CUTVOL & vbTab & _
                           ARRAYDATA(ARRAYDATAidx).FILLVOL
   Next
Exit Sub
Error_Cols_Value:
   MsgBox "Value cols NOK : Column 1 is bigger then Column 2 !"
Exit Sub
Error_Cols_Nul:
   MsgBox "Value cols NOK !"
End Sub

Public Sub cmdNext_Click()
Dim ARRAYDATAidx As Double
Dim GRIDCALCROW As Integer
   On Error GoTo Error_Filling
   With frmMainMenu
      With .GridFraTESCalc
         .Clear
         .TextMatrix(0, 0) = "Water Depth" ' reset titels
         .TextMatrix(0, 1) = "Cummulative Volume" ' reset titels
         .TextMatrix(1, 0) = ARRAYDATA(1).DEPTH1
         .TextMatrix(1, 1) = "0.0"
         ' loop trough the ARRAYDATA and add each line in the GridFraTesCalc
         For ARRAYDATAidx = 2 To UBound(ARRAYDATA)
            If ARRAYDATA(ARRAYDATAidx - 1).CUTVOL <> "" Then
               .AddItem ARRAYDATA(ARRAYDATAidx).DEPTH1 & vbTab & _
               CStr(Format(CSng(ARRAYDATA(ARRAYDATAidx - 1).CUTVOL) + _
               CSng(.TextMatrix(ARRAYDATAidx - 1, 1)), "#.0"))
            Else
               .AddItem ARRAYDATA(ARRAYDATAidx).DEPTH1 & vbTab & _
               CStr(Format(CSng(ARRAYDATA(ARRAYDATAidx - 1).FILLVOL) + _
               CSng(.TextMatrix(ARRAYDATAidx - 1, 1)), "#.0"))
            End If
         Next
' fill the graph data in the ARRAYGRAPH
         ReDim ARRAYGRAPH(1 To .Rows - 1, 1 To 2)
         For GRIDCALCROW = 1 To .Rows - 1
            ARRAYGRAPH(GRIDCALCROW, 1) = .TextMatrix(GRIDCALCROW, 1)
            ARRAYGRAPH(GRIDCALCROW, 2) = .TextMatrix(GRIDCALCROW, 0)
         Next
      End With
' set the graph
      With .ChartFraTESCalc
         .chartType = VtChChartType2dXY
         With .Plot
            .UniformAxis = False
            With .Axis(VtChAxisIdX)
               .AxisTitle.Text = "Volume"
               .ValueScale.Auto = True ' Turn on the auto scale
               .ValueScale.Maximum = ARRAYGRAPH(UBound(ARRAYGRAPH), 1) ' set the max and min.
               .ValueScale.Minimum = ARRAYGRAPH(LBound(ARRAYGRAPH), 1)
               .Intersection.Auto = False
               .Intersection.LabelsInsidePlot = False
            End With
            With .Axis(VtChAxisIdY)
               .AxisTitle.Text = "Depth"
               .AxisTitle.TextLayout.VertAlignment = VtVerticalAlignmentCenter
               .AxisTitle.TextLayout.Orientation = VtOrientationUp
               .ValueScale.Auto = True
               .ValueScale.Maximum = ARRAYGRAPH(UBound(ARRAYGRAPH), 2)
               .ValueScale.Minimum = ARRAYGRAPH(LBound(ARRAYGRAPH), 2)
               '.ValueScale.MajorDivision = -1
            End With
         End With
         .ChartData = ARRAYGRAPH
         .Refresh
      End With
      .FrameTES.ZOrder
      .Show
   End With
   Me.Hide
Exit Sub
Error_Filling:
   MsgBox "No valid data in Grid !"
End Sub







